/// <reference path="../../ext-6.0.2-classic.d.ts" />

Ext.define('LMSplaylistEditor.store.AllAlbums', {
	extend: 'Ext.data.BufferedStore',
	requires: ['LMSplaylistEditor.model.SlimAlbum'],
	model: 'LMSplaylistEditor.model.SlimAlbum',

	autoLoad: false,
	remoteSort: true,
	remoteGroup: true,	

	pageSize: 500,
	leadingBufferZone: 200,
	trailingBufferZone:100,
	purgePageCount: 0,

	proxy: {
		type: 'jsonp',
		disableCaching: false,
		timeout: 30000,
		url: LMSplaylistEditor.RuntimeConfig.config.JSONPURL,
		remoteSort: false,
		remoteGroup: false,
		extraParams: {
			args: Ext.JSON.encode( {
					cmd: 'getAllAlbums'
			})
		},
		reader: {
			type: 'json',
			rootProperty: 'results.albums_loop',
			totalProperty: 'results.count'
		}
	}
});
