/// <reference path="../../ext-6.0.2-classic.d.ts" />

Ext.define('LMSplaylistEditor.store.AllArtists', {
	extend: 'Ext.data.BufferedStore',
	requires: ['LMSplaylistEditor.model.SlimArtist'],
	model: 'LMSplaylistEditor.model.SlimArtist',
	alias: 'store.allartistsstore',

	autoLoad: true,
	pageSize: 10000,
	leadingBufferZone: 5000,
	trailingBufferZone: 5000,
	purgePageCount: 0,

	proxy: {
		type: 'jsonp',
		disableCaching: false,
		timeout: 30000,
		url: LMSplaylistEditor.RuntimeConfig.config.JSONPURL,
		remoteSort: false,
		remoteGroup: false,
/*
		limitParam: '',
		pageParam: '',
		startParam: '',
*/
		extraParams: {
			args: Ext.JSON.encode( {
					cmd: 'getAllArtists'
			})
		},
		reader: {
			type: 'json',
			rootProperty: 'results.artists_loop',
			totalProperty: 'results.count'
		}
	}


});
