Ext.define('LMSplaylistEditor.ux.CoverWin', {
	extend: 'Ext.window.Window',
	styleHtmlContent: true,
	closeAction: 'destroy',
	autoScroll: true,
	modal: false,
	layout: "fit",
	
	offW: 100,
	offH: 100,
	currentImageRec: {},
	allImages: {},
	currentTrackName: "",
	currentArtistName: "",
	
	initComponent: function() {
		this.tools = [{
			type: 'zoomout', 
			tooltip: 'Fit image to window',
			handler: function(event, toolEl, panel) {
				var win = panel.findParentByType('window');
				var wh = win.getImageSize( win.currentImageRec);
				win.update('<center><img src="'+win.currentImageRec.url+'" width='+wh[0]+" height="+wh[1]+"/></center>");
			},
			scope: this
		},{
			type: 'zoomin', 
			tooltip: 'Original image size',
			handler: function(event, toolEl, panel) {
				var win = panel.findParentByType('window');
				win.update('<center><img src="'+win.currentImageRec.url+'" width='+win.currentImageRec.width+" height="+win.currentImageRec.height+"/></center>");
			},
			scope: this
		},{
			//type: 'prev', 
			iconCls: 'x-fa fa-arrow-left',
			hidden: (this.allImages.length > 1)?false:true,
			handler: function(event, toolEl, panel) {
				var win = panel.findParentByType('window');
				win.switchWindowImage( -1);
			},
			scope: this
		},{
//			type: 'next', 
			iconCls: 'x-fa fa-arrow-right',
			hidden: (this.allImages.length > 1)?false:true,
			handler: function(event, toolEl, panel) {
				var win = panel.findParentByType('window');
				win.switchWindowImage( 1);
			},
			scope: this
		}];

		var wh = this.getWindowSize( this.currentImageRec);
		this.setWidth( wh[0]);
		this.setHeight( wh[1]);
	
		this.callParent( arguments);
//		this.on("show",this.onShow, this);
	},
	
	beforeShow: function() {
		var wh = this.getImageSize( this.currentImageRec);
		//this.update('<center><img src="'+this.currentImageRec.url+'" width='+wh[0]+" height="+wh[1]+"/></center>");
		this.update('<div align="center"><img src="'+this.currentImageRec.url+'" width='+wh[0]+" height="+wh[1]+"/></div>");
		this.center();
	},
	
	switchWindowImage: function(pos) {
		var currentImageIdx = -1;
		for( var i = 0; i < this.allImages.length; i++) {
			if( this.allImages[i].name == this.currentImageRec.name) {
				currentImageIdx = i;
			}
		}
		if( currentImageIdx == -1 ||  currentImageIdx+pos == this.allImages.length || currentImageIdx+pos < 0) {
			return;
		}
		var v = this.allImages[currentImageIdx+pos];
		var wh = this.getWindowSize( v);
		this.setWidth( wh[0]);
		this.setHeight( wh[1]);
		this.setTitle( v.name + " (\""+this.currentTrackName+'"'+" by "+this.currentArtistName+")" );
		this.currentImageRec = v;
		var wh = this.getImageSize( v);
		this.update('<div align="center"><img src="'+v.url+'" width='+wh[0]+" height="+wh[1]+"/></div>");
	},
	getWindowSize: function( v) {
		var h = ((v.height+this.offH) > Ext.getBody().getSize().height)?"100%":(v.height+this.offH);
		var w = ((v.width+this.offW) > Ext.getBody().getSize().width)?"100%":(v.width+this.offW);
		return [w,h];
	},
	getImageSize: function( img) {
		//var wwh = win.body.getSize();
		//var wwh = win.body.getViewSize();

		var wwh = Ext.getBody().getSize();
		console.log("gIS: init w="+wwh.width+" h="+wwh.height);
		wwh.width -= this.offW;
		wwh.height -= this.offH;

		var w = (img.width > wwh.width)?wwh.width:img.width;
		var h = (img.height > wwh.height)?wwh.height:img.height;
		if( img.width > wwh.width || img.height > wwh.height) {
			var vf = wwh.height / img.height;
			var hf = wwh.width / img.width;
			var imf = Math.min(vf, hf);
			h = img.height*imf;
			w = img.width*imf;
		}
		console.log("gIS: final w="+w+" h="+h);
		return [w,h];
	}
	
});