Ext.define('LMSplaylistEditor.ux.PanelSearchCustomItem', {
	extend: 'Ext.panel.Panel',
	xtype: 'slim-searchfilteritem',
	alias: 'widget.slim-searchfilteritem',
	requires: ['Ext.slider.Single', 'Ext.slider.Multi'],
//	id: 'SearchFilterItem',
	
//	border: 1,
//	style: {
//		borderColor: 'red',
//		borderStyle: 'solid'
//	},
	layout: {
		type: 'hbox',
		align: 'middle',
		pack: "start",
		padding: "5 10 5 10"
	},
	features: [{
		ftype: 'filters',
		autoReload: false,
		local: true
	}],

	statics : {
		TYPE_GENRE: 1,
		TYPE_ARTIST: 2,
		TYPE_RATING: 3,
		TYPE_YEAR: 4
		
	},
	
	buttonWidth: 130,
	
	itemType: 0,
	itemDescr: '',
	itemIncl: true,
	dbSearchString: {},
	dbAttString: {},
	initItemConfig: false,
	
	selArtists: [],
	selGenres: [],
	selYearFrom: 1980,
	selYearTo: 2012,
	selRatingFrom: 0,
	selRatingTo: 5,

	initComponent: function() {
		
		this.iconMap = {};
		/*
		this.iconMap[LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_GENRE] = 'music.png';
		this.iconMap[LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_ARTIST] = 'user_female.png';
		this.iconMap[LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_RATING] = 'thumb_up.png';
		this.iconMap[LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_YEAR] = 'calendar_view_day.png';
		*/
		this.iconMap[LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_GENRE] = 'fa-music';
		this.iconMap[LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_ARTIST] = 'fa-user-secret';
		this.iconMap[LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_RATING] = 'fa-thumbs-up';
		this.iconMap[LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_YEAR] = 'fa-calendar';
		
		
		this.items = [
//			Ext.create('Ext.Img', { src: "resources/images/"+this.iconMap[this.itemType], padding: "10 10 10 0" }),
			{
				xtype: 'cycle',
				// FIXME: should work
				//iconCls: 'x-fa '+this.iconMap[this.itemType],
				showText: true,
				prependText: 'Mode: ',
				//width: this.buttonWidth+0,
				margin: "5 10 5 0",
				menu: {
					items: [{
						text: 'Include',
						checked: true
						},{
						text: 'Exclude'
					}]
				},
				changeHandler: function(cycleBtn, activeItem) {
					if( activeItem.itemIndex == 0) {
						this.itemIncl = true;
					} else {
						this.itemIncl = false;
					}
				},
				scope: this
			}
		];

		if( this.itemType == LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_GENRE) {
			this.items.push( this.getGenreButton());
		} else if( this.itemType == LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_ARTIST) {
			this.items.push( this.getArtistButton());
		} else if( this.itemType == LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_YEAR) {
			this.items.push( this.getYearButton());
		} else if( this.itemType == LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_RATING) {
			this.items.push( this.getRatingButton());
		}

		this.items[1].setIconCls('x-fa '+this.iconMap[this.itemType]);

		this.items.push({
			xtype: 'button',
			iconCls: 'x-fa fa-remove',
			margin: "5 0 5 10",
			tooltip: "Remove condition",
			handler: function() {
				this.fireEvent('removeMe', this);
			},
			scope: this
		});

//		console.log("iconCls: "+'x-fa '+this.iconMap[this.itemType]);

		this.callParent( arguments);
	},
	
	getGenreButton: function() {
		var genreGrid = Ext.create('Ext.grid.Panel', {
			store: 'AllGenres',
			selModel: Ext.create('Ext.selection.CheckboxModel'),
			columns: [{
				header: 'Genres',
				dataIndex: 'genre',
				flex: 1,
				filter: true
				}],
			frame: true,
			layout: {
				type: 'fit'
			}
		});
		
		if( this.initItemConfig) {
			var rec = genreGrid.getStore().getById( this.initItemConfig.data.genreid);
			genreGrid.getSelectionModel().select( rec);
			this.selGenres = [this.initItemConfig.data.genreid];

//			genreGrid.on("render", function() {
//				genreGrid.getSelectionModel().select( [rec]);
//			}, this);
		}
		
		var genreWin = Ext.create('widget.window', {
			title: 'Choose genres',
			closable: false,
			closeAction: 'hide',
			width: 350,
			height: "80%",
			modal: true,
			layout: {
				type: 'fit'
			},
			buttons: [{
				text: 'OK',
				handler: function() {
					var s = genreGrid.getSelectionModel();
					var me = this;
					me.selGenres = [];
					me.itemDescr = "";
					Ext.each (s.getSelection(), function( v) {
						me.selGenres.push( v.get('id'));
						me.itemDescr += (v.get('genre')+" / ");
					});
					me.itemDescr = me.itemDescr.substring(0,me.itemDescr.length-1);
					genreButton.setTooltip( me.itemDescr);
					
					genreWin.hide();
				},
				scope: this
			}],
			items: [
				genreGrid
			]});
		var genreButton = Ext.create('Ext.Button', {
			text: 'Choose genres',
			width: this.buttonWidth,
			handler: function() {
				genreWin.show();
			}
		});
		return genreButton;
	},
	getArtistButton: function() {
		var artistGrid = Ext.create('Ext.grid.Panel', {
			store: 'AllArtists',
			selModel: Ext.create('Ext.selection.CheckboxModel'),
			columns: [{
				header: 'Artists',
				dataIndex: 'artist',
				flex: 1,
				filter: true
				}],
			frame: true,
			layout: {
				type: 'fit'
			}
		});
		
		var artistWin = Ext.create('widget.window', {
			title: 'Choose artists',
			closable: false,
			closeAction: 'hide',
			width: 350,
			height: "80%",
			modal: true,
			layout: {
				type: 'fit'
			},
			buttons: [{
				text: 'OK',
				handler: function() {
					var s = artistGrid.getSelectionModel();
					var me = this;
					me.selArtists = [];
					me.itemDescr = "";
					Ext.each (s.getSelection(), function( v) {
						me.selArtists.push( v.get('id'));
						me.itemDescr += (v.get('artist')+" / ");
					});
					me.itemDescr = me.itemDescr.substring(0,me.itemDescr.length-1);
					artistButton.setTooltip( me.itemDescr);
					
					artistWin.hide();
				},
				scope: this
			}],
			items: [
				artistGrid
			]});
		var artistButton = Ext.create('Ext.Button', {
			text: 'Choose artists',
			width: this.buttonWidth,
			handler: function() {
				artistWin.show();
			}
		});
		return artistButton;
	},
	getYearButton: function() {
		var yearSlider = Ext.create('Ext.slider.Multi', {
					width: 200,
					values: [1999, 2013],
					increment: 1,
					minValue: 1850,
					maxValue: 2020,
					labelAlign: "top",
					fieldLabel: "Years Range",
					padding: 10
					});

		var yearWin = Ext.create('widget.window', {
			title: 'Choose years',
			closable: false,
			closeAction: 'hide',
			width: 250,
			height: 150,
			modal: true,
			layout: {
				type: 'fit'
			},
			buttons: [{
				text: 'OK',
				handler: function() {
					var s = yearSlider.getValues();
					this.selYearFrom = s[0];
					this.selYearTo = s[1];
					this.itemDescr = this.selYearFrom+"-"+this.selYearTo;
					yearButton.setTooltip( this.itemDescr);
					
					yearWin.hide();
				},
				scope: this
			}],
			items: [
				yearSlider
			]});
		var yearButton = Ext.create('Ext.Button', {
			text: 'Choose years',
			width: this.buttonWidth,
			handler: function() {
				yearWin.show();
			}
		});
		return yearButton;
	},
	getRatingButton: function() {
		var ratingSlider = Ext.create('Ext.slider.Multi', {
					width: 100,
					values: [0, 5],
					increment: 1,
					minValue: 0,
					maxValue: 5,
					labelAlign: "top",
					fieldLabel: "Ratings Range"
					});

		var ratingWin = Ext.create('widget.window', {
			title: 'Choose ratings',
			closable: false,
			closeAction: 'hide',
			width: 250,
			height: 150,
			modal: true,
			layout: {
				type: 'fit'
			},
			buttons: [{
				text: 'OK',
				handler: function() {
					var s = ratingSlider.getValues();
					this.selRatingFrom = s[0];
					this.selRatingTo = s[1];
					this.itemDescr = this.selRatingFrom+"-"+this.selRatingTo;
					ratingButton.setTooltip( this.itemDescr);
					
					ratingWin.hide();
				},
				scope: this
			}],
			items: [
				ratingSlider
			]});
		var ratingButton = Ext.create('Ext.Button', {
			text: 'Choose ratings',
			iconCls: 'x-fa fa-thumbs-up',
			width: this.buttonWidth,
			handler: function() {
				ratingWin.show();
			}
		});
		return ratingButton;
	},
	
	updateDBCondition: function() {
		if( this.itemType == LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_GENRE) {
			if( this.itemIncl) {
				this.dbSearchString = {'genreTracks.genre': this.selGenres };
			} else {
				//this.dbSearchString = {'genreTracks.genre': {"!=":this.selGenres} };
				this.dbSearchString = {'genreTracks.genre': {"not in":this.selGenres} };
			}
			//this.dbAttString = {join: "genreTracks", prefetch: "genreTracks"};
			this.dbAttString = {join: "genreTracks"};
		} else if( this.itemType == LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_YEAR) {
			if( this.itemIncl) {
				this.dbSearchString = {'me.year': {'>=':this.selYearFrom, '<=':this.selYearTo}};
			} else {
				this.dbSearchString = {'me.year': [{'<':this.selYearFrom}, {'>':this.selYearTo}], '-and':{'me.year':{"!=":0}}};
			}
		} else if( this.itemType == LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_ARTIST) {
			if( this.itemIncl) {
				this.dbSearchString = {'primary_artist': this.selArtists };
			} else {
				this.dbSearchString = {'primary_artist': {"not in":this.selArtists} };
			}
		} else if( this.itemType == LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_RATING) {
			//this.dbAttString = {prefetch: "persistent"};
			if( this.itemIncl) {
				this.dbSearchString = {'persistent.rating': {'>=':this.selRatingFrom*20, '<=':this.selRatingTo*20}};
			} else {
				this.dbSearchString = {'persistent.rating': [{'<':this.selRatingFrom*20}, {'>':this.selRatingTo*20}], '-and':{'persistent.rating':{"!=":0}}};
			}
		}
	}

});