Ext.define('LMSplaylistEditor.ux.SlimGridAlbumSearchResults', {
	extend: 'LMSplaylistEditor.ux.SlimGridAlbumsBase',
	xtype: 'slim-grid-albumsearchresults',
	alias: 'widget.slim-grid-albumsearchresults',
	id: 'SlimGridAlbumSearchResults',
	reference: 'slim_grid_album_search',
	controller: 'SlimSearchController',

//	store: 'AlbumSearchResults',
	store: Ext.create( 'LMSplaylistEditor.store.AlbumSearchResults', {storeId:'AlbumSearchResults'}),
	listeners: {
		itemdblclick: 'onSearchAlbumsDoubleClick',
		scope: 'controller'
    },

/*	columns: [
		{ text: '', dataIndex: 'artwork', width: 60, menuDisabled: true, sortable: false, renderer: function( value) {
			return Ext.DomHelper.markup({
				tag : 'img',
				src: '/music/' + value + '/cover_50x50_p.png',
				width: 50,
				height: 50
				});		
			}
		},{ 
			text: 'Title', dataIndex: 'title', flex:2, filter:true, renderer: function( value, metaData, record, rowIndex, colIndex, store) {
				return value
						+"<br>Duration: " + record.get('duration')
						+"<br>Compilation: " + ((record.get('compilation'))?"Yes":"No");
			}
		},{ 
			text: 'Artist', dataIndex: 'contributor', filter:true, flex: 1
		},{ 
			text: 'Year', dataIndex: 'year', filter:true, width: 40, renderer: function( value) {
				return (value!=0)?value:"";
			}
		}
	],
*/
	tbar: [
			{
				xtype: 'textfield',
				id: 'albumsearchresults-field-album-name',
				reference: 'albumsearchresults_field_album_name',
				allowBlank: false,
				hidelLabel: true,
				minLength: 2,
				listeners: {
					specialkey: 'onAlbumSearchFieldSubmit',
					scope: 'controller'
				}
			},{
				xtype: 'button', 
				tooltip: 'Search',
				id: "albumsearchresults-button-search",
				iconCls: 'x-fa fa-search',
				scale: 'small'	,
				listeners: {
					click: 'onAlbumSearchButtonClick',
					scope: 'controller'
				}
			},{ 
				xtype: 'tbseparator' 
			},
			/*
			{
				xtype: 'button', 
				tooltip: 'Show statistics for selected albums',
				id: "albumsearchresults-button-info",
				iconCls: 'x-fa fa-info-circle',
				scale: 'small',
				listeners: {
					click: 'onAlbumInfoButtonClick',
					scope: 'controller'
				}
			},
			{ 
				xtype: 'tbseparator' 
			},
			*/
			{
				xtype: 'button', 
				tooltip: 'Go back to the panel which started this search',
				id: "albumsearchresults-button-back",
				iconCls: 'x-fa fa-arrow-left',
				scale: 'small',
				listeners: {
					click: 'onAlbumSearchResultNavigateBack',
					scope: 'controller'
				}
			}
	],
	
	currentArtistId: 0,
	
	initComponent: function() {
		this.callParent( );
	},

	search: function( name) {
		args = {
				cmd: 'searchAlbumsByName',
				name: name
			};
		this.getStore().getProxy().setExtraParam('args', Ext.JSON.encode(args));
		this.getStore().load({
			scope: this,
			callback: function(records, operation, success) {
				if( success) {
					this.setTitle( "Albums ("+this.getStore().getTotalCount()+")");
				}
			}
		});
	},
	showAlbumsByArtist: function( aid) {
		if (aid != this.currentArtistId) {
			this.getStore().getProxy().setExtraParam('args', Ext.JSON.encode( {cmd: 'getAlbumsByArtist', artistid: aid }));
			var f = function( aid){ return function( records, operation, success) {
				if (success) {
						this.setTitle( "Albums ("+this.getStore().getTotalCount()+")");
						this.currentArtistId = aid;
						this.getView().refresh();
					}
			}};
			this.getStore().load({
				scope: this,
				callback: f(aid)
			});
		}
	},
	showAlbumsByCustomSearch: function( args) {
			this.getStore().getProxy().setExtraParam('args', Ext.JSON.encode( args));
			var f = function(){ return function( records, operation, success) {
				if (success) {
						this.currentArtistId = 0;
						this.setTitle( "Albums ("+this.getStore().getTotalCount()+")");
						this.getView().refresh();
					}
			}};
			this.getStore().load({
				scope: this,
				callback: f()
			});
	}	
});