Ext.define('LMSplaylistEditor.ux.SlimMenuContextTrack', {
	extend: 'Ext.menu.Menu',
	requires: ['LMSplaylistEditor.Utils'],
	id: "menu-context-track",
	
	grid: {},
	currentTrackId: 689687,
	currentAlbumId: 689687,
	currentArtistId: 689687,
	
	initComponent: function() {
/*
		this.trackItem = Ext.create('Ext.menu.Item',{
			text: 'Track',
			icon: "images/music.png"
		});

*/
		this.items = [{
			text: 'Please wait...',
			icon: "images/time.png"
			}];

		Ext.define('Item', {
			extend: 'Ext.data.Model',
			fields: [ 'id', {name:'isaudio', type:'boolean'}, {name:'hasitems', type:'boolean'}, 'name', 'type']
		});
		
		this.trackItemsStore = Ext.create('Ext.data.Store', {
			model: 'Item',
			autoLoad: false,
			proxy: {
					type: 'jsonp',
					disableCaching: false,
					timeout: 20000,
					url: '/plugins/LMSnewGUI/js.html',
					extraParams: {
						args: Ext.JSON.encode( {
								cmd: 'getItemContextItems',
								player: playerid,
								id: 0,
								idtype: 'track'
						})
					},
					reader: {
						type: 'json',
						root: 'results.loop_loop',
						totalProperty: 'results.count'
					}
				}			
		});
		
		this.callParent( arguments);
		this.on('beforeshow', this.refreshStore, this);
		this.trackItemsStore.on("load", this.onTrackStoreLoad, this);
	},
	
	refreshStore: function() {
		this.trackItemsStore.getProxy().setExtraParam("args", this.getParmsTrack( this.currentTrackId));
		this.trackItemsStore.load();
	},
	
	onTrackStoreLoad: function( store, records, successful, eOpts ) {
		this.createTrackMenu( records);
	},
/*
	createTrackMenu_: function( records) {
		var mi = [];
		var me = this;
		this.removeAll();
		Ext.each( records, function( v) {
			var type = v.get('type');
			if ( type != "text" && type != "redirect" && type != "playlist") {
				var icon = "images/cog.png";
				if( type == "playlist") {
					icon = "images/music.png";
				} else if (type == "link") {
				} else {
				}
				
				var it = Ext.create('Ext.menu.Item',{
					text: v.get('name'),
					plain: false,
					icon: icon,
					handler: function( i,e) {
						LMSplaylistEditor.Utils.slimRequest({
							params: ['trackinfo', v.get('isaudio')?'playlist':'items', 0, 999, 'track_id:'+me.currentTrackId,'item_id:'+v.get('id')],
							scope: this,
							success: function( response, options) {
								var r = Ext.JSON.decode(response.responseText);
								if( r.result.loop_loop.length == 1 && r.result.loop_loop[0].type == "text") {
									me.fireEvent("showInfo", r.result.loop_loop[0].name);
								} else {
									var oldParms = (r.params[1][4]).split(":");
									var theText = "";
									var subItems = [];
									Ext.each( r.result.loop_loop, function(v) {
										if( v.type == "text") {
											theText += (v.name+"<br>");
										} else if (! v.type) {
											var sit = Ext.create('Ext.menu.Item',{
												text: v.name,
												plain: false,
												handler: function( i,e) {
													LMSplaylistEditor.Utils.slimRequest({
														params: ['trackinfo', 'items', 0, 999, 'track_id:'+oldParms[1],'item_id:'+v.id],
														success: function( response, options) {
														}
													});
												}
											});
											subItems.push(sit);
										}
									});
									if( theText) {
										Ext.create('LMSplaylistEditor.ux.InfoWin', {
											title: "Info",
											html: theText
										}).show();
									}
									if ( subItems.length > 2) {
										Ext.create('Ext.menu.Menu', { items: subItems}).show();
									}
								}
							}
						});
					}
				});
				me.add( it);
			}
		});
	},
*/
	createTrackMenu: function( records) {
		var me = this;
		this.removeAll();
		var menuItem;
		Ext.each( records, function( v) {
			var type = v.get('type');
			if ( type != "text" && type != "redirect" && type != "playlist") {
				var icon;
				if (type == "link") {
					icon = "images/bullet_go.png";
				} else {
					icon = "images/bullet_black.png";
				}
				
				var it = Ext.create('Ext.menu.Item',{
					text: v.get('name'),
					plain: false,
					icon: icon,
					handler: function( i,e) {
						LMSplaylistEditor.Utils.slimRequest({
							params: ['trackinfo', v.get('isaudio')?'playlist':'items', 0, 999, 'track_id:'+me.currentTrackId,'item_id:'+v.get('id')],
							scope: this,
							success: me.createHandlerFn( me, menuItem)
						});
					}
				});
				me.add( it);
			}
		});
	},
	
	createHandlerFn: function( me, menuItem) {
		var f = function( me, menuItem) {
			return function( response, options) {
				var r = Ext.JSON.decode(response.responseText);
				if (r.result.count == 0) {
					return;
				}
				if( r.result.loop_loop.length == 1 && r.result.loop_loop[0].type == "text" && r.result.loop_loop[0].name.length < 100) {
					me.fireEvent("showInfo", Ext.String.escape( r.result.loop_loop[0].name));
				} else {
					var oldParms = (r.params[1][4]).split(":");
					var theText = "";
					var subItems = [];
					Ext.each( r.result.loop_loop, function(v) {
						if( v.type == "text") {
							theText += (v.name+"<br>");
						} else if (! v.type) {
							var sit = Ext.create('Ext.menu.Item',{
								text: Ext.String.escape(v.name),
								plain: false,
								icon: "images/bullet_black.png",
								handler: function( i,e) {
									LMSplaylistEditor.Utils.slimRequest({
										params: ['trackinfo', 'items', 0, 999, 'track_id:'+oldParms[1],'item_id:'+v.id],
										success: me.createHandlerFn( me, menuItem)
									});
								}
							});
							subItems.push(sit);
						} else if ( v.type == "search") {
							var sit = Ext.create('Ext.form.field.Text',{
								fieldLabel: Ext.String.escape(v.name),
								size: 10,
								minLength: 3,
								labelAlign: "right",
								labelClsExtra: "x-menu-item-text",
								fieldCls: "x-menu-item-text",
								listeners: {
									specialkey: function(f, e) {
										if (e.getKey() == e.ENTER && f.getValue()) {
											LMSplaylistEditor.Utils.slimRequest({
												params: ['trackinfo', 'items', 0, 999, 'track_id:'+oldParms[1],'item_id:'+v.id,"search:"+f.getValue()],
												success: me.createHandlerFn( me, menuItem)
											});
										}
									}
								}
							});
							subItems.push(sit);
						}
					});
					if( theText) {
						Ext.create('LMSplaylistEditor.ux.InfoWin', {
							title: "Info",
							html: theText
						}).show();
					}
					if ( subItems.length > 0) {
						Ext.create('Ext.menu.Menu', { items: subItems}).show();
					}
				}
			};
		};
		return f(me, menuItem);
	},
	
	
	getParmsTrack: function( tid) {
		return Ext.JSON.encode( {
				cmd: 'getItemContextItems',
				player: playerid,
				id: tid,
				idtype: 'track'
		});
	},
	setCurrentInfo: function( artistid, albumid, trackid) {
		this.currentTrackId = trackid;
		this.currentAlbumId = albumid;
		this.currentArtistId = artistid;
	},
});